/*
 * ==========================================================================================
 * conf.h
 *
 * Date: 10 May 2004 
 * Author: Jerome Delamarche
 * Version: 1.3 
 *
 * ------------------------------------------------------------------------------------------
 * CHANGES:
 *
 * ------------------------------------------------------------------------------------------
 *
 * TODO:
 *
 * ------------------------------------------------------------------------------------------
 *
 * Manages with the XML configuration file
 *
 * ==========================================================================================
 */
#ifndef _mod_parmguard_conf_h_
#define _mod_parmguard_conf_h_

#include <stdarg.h>
#include <libxml/SAX.h>
#include "rules.h"

typedef struct {
	const char 	*filename;
	time_t	   	last_mtime;
	guard_ctxt_t 	*rules;
} conf_file_t;

void InitConf(void (*errfunc)(const char *format,...));
void EndConf(void);
conf_file_t *CheckFileConf(const char *filename);
xmlDocPtr ReadConfFile(const char *fname);
conf_file_t *StoreFileConf(const char *fname, guard_ctxt_t *ctxt);
void UpdateFileConf(conf_file_t *conffile, guard_ctxt_t *ctxt);
guard_ctxt_t *GetFileConf(conf_file_t *conffile);
void CheckLastTimeConf(void (*updateConf)(conf_file_t *conffile));

#endif /* _mod_parmguard_h_ */

/* EOF */
